package org.processmininguc.configurableprocesses.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.processtree.ProcessTree;
import org.processmininguc.configurableprocesses.parameters.GreedyParameters;

public class GreedyDialog extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -60087716353524468L;
	/**
	 * The JPanel that allows the user to set (a subset of) the parameters.
	 */
	public GreedyDialog(UIPluginContext context, ProcessTree tree, XLog log, final GreedyParameters parameters) {
		sectionQualityMetrics(context, tree, log, parameters);
	}
	
	public void sectionQualityMetrics(UIPluginContext context, ProcessTree tree, XLog log, final GreedyParameters parameters){

		////// Conformance JPanel
		JPanel containerConformance = new JPanel(new GridBagLayout());
		containerConformance.setPreferredSize(new Dimension(340, 280));
	    containerConformance.setBorder(BorderFactory.createTitledBorder("Conformance"));
	    //BoxLayout layoutConformance = new BoxLayout(containerConformance, BoxLayout.Y_AXIS);
	    //containerConformance.setLayout(layoutConformance);

	    //Adding the four quality conformance metrics
	    JLabel labelFitness = new JLabel("Fitness");
	    GridBagConstraints c = new GridBagConstraints();
	    c.gridx = 0;
	    c.gridy = 0;
	    c.insets = new Insets(10,10,10,10);
	    containerConformance.add(labelFitness,c);
	    
	    //containerConformance.add(new JLabel("Fitness"));	    
		SpinnerModel sm3 = new SpinnerNumberModel(parameters.getFitnessWeigth(), 0, 100, 1);
		final JSpinner textFitness = new JSpinner(sm3);
		textFitness.addChangeListener(new ChangeListener() {
			  @Override
			  public void stateChanged(ChangeEvent e) {
				  Object sp = textFitness.getValue();
				  parameters.setFitnessWeigth(Integer.parseInt(sp.toString()));
			  }
		});
	    c.gridx = 1;
	    c.gridy = 0;			
		containerConformance.add(textFitness,c);

		
	    c.gridx = 0;
	    c.gridy = 1;			
		JLabel labelPrecision = new JLabel("Precision");
	    containerConformance.add(labelPrecision,c);
		SpinnerModel sm4 = new SpinnerNumberModel(parameters.getPrecisionWeigth(), 0, 100, 1);
		final JSpinner textPrecision = new JSpinner(sm4);
		textPrecision.addChangeListener(new ChangeListener() {
			  @Override
			  public void stateChanged(ChangeEvent e) {
				  Object sp = textPrecision.getValue();
				  parameters.setPrecisionWeigth(Integer.parseInt(sp.toString()));
			  }
		});
	    c.gridx = 1;
	    c.gridy = 1;			
		containerConformance.add(textPrecision,c);		

	    c.gridx = 0;
	    c.gridy = 2;			
		JLabel labelGeneralization = new JLabel("Generalization");
	    containerConformance.add(labelGeneralization,c);
	    SpinnerModel sm5 = new SpinnerNumberModel(parameters.getGeneralizationWeigth(), 0, 100, 1);
		final JSpinner textGeneralization = new JSpinner(sm5);
		textGeneralization.addChangeListener(new ChangeListener() {
			  @Override
			  public void stateChanged(ChangeEvent e) {
				  Object sp = textGeneralization.getValue();
				  parameters.setGeneralizationWeigth(Integer.parseInt(sp.toString()));
			  }
		});
	    c.gridx = 1;
	    c.gridy = 2;			
		containerConformance.add(textGeneralization,c);		

		
	    c.gridx = 0;
	    c.gridy = 3;			
		JLabel labelSimplicity = new JLabel("Simplicity");
		containerConformance.add(labelSimplicity,c);
		SpinnerModel sm6 = new SpinnerNumberModel(parameters.getSimplicityWeigth(), 0, 100, 1);
		final JSpinner textSimplicity = new JSpinner(sm6);
		textSimplicity.addChangeListener(new ChangeListener() {
			  @Override
			  public void stateChanged(ChangeEvent e) {
				  Object sp = textSimplicity.getValue();
				  parameters.setSimplicityWeigth(Integer.parseInt(sp.toString()));
			  }
		});
	    c.gridx = 1;
	    c.gridy = 3;			
		containerConformance.add(textSimplicity,c);		

		add(containerConformance);		
	}
	

}
